| Flutter Impeller |

Public Types | Public Member Functions | List of all members
impeller::DlPlayground Class Reference

`#include <dl_playground.h>`

Inheritance diagram for impeller::DlPlayground:

## Public Types
using | DisplayListPlaygroundCallback = std::function< sk_sp< flutter::DisplayList >()>
Public Types inherited from impeller::Playground
using | SinglePassCallback = std::function< bool(RenderPass &pass)>

## Public Member Functions
| DlPlayground ()
| ~DlPlayground ()
bool | OpenPlaygroundHere (flutter::DisplayListBuilder &builder)
bool | OpenPlaygroundHere (sk_sp< flutter::DisplayList > list)
bool | OpenPlaygroundHere (DisplayListPlaygroundCallback callback)
SkFont | CreateTestFontOfSize (SkScalar scalar)
SkFont | CreateTestFont ()
sk_sp< flutter::DlImage > | CreateDlImageForFixture (const char *fixture_name, bool enable_mipmapping=false) const
Public Member Functions inherited from impeller::PlaygroundTest
| PlaygroundTest ()
virtual | ~PlaygroundTest ()
void | SetUp () override
void | TearDown () override
PlaygroundBackend | GetBackend () const
std::unique_ptr< fml::Mapping > | OpenAssetAsMapping (std::string asset_name) const override
RuntimeStage::Map | OpenAssetAsRuntimeStage (const char *asset_name) const
std::string | GetWindowTitle () const override
Public Member Functions inherited from impeller::Playground
| Playground (PlaygroundSwitches switches)
virtual | ~Playground ()
void | SetupContext (PlaygroundBackend backend, const PlaygroundSwitches &switches)
void | SetupWindow ()
void | TeardownWindow ()
bool | IsPlaygroundEnabled () const
Point | GetCursorPosition () const
ISize | GetWindowSize () const
Point | GetContentScale () const
Scalar | GetSecondsElapsed () const
| Get the amount of time elapsed from the start of the playground's execution. More...
std::shared_ptr< Context > | GetContext () const
std::shared_ptr< Context > | MakeContext () const
bool | OpenPlaygroundHere (const Renderer::RenderCallback &render_callback)
bool | OpenPlaygroundHere (SinglePassCallback pass_callback)
std::shared_ptr< Texture > | CreateTextureForFixture (const char *fixture_name, bool enable_mipmapping=false) const
std::shared_ptr< Texture > | CreateTextureCubeForFixture (std::array< const char *, 6 > fixture_names) const
fml::Status | SetCapabilities (const std::shared_ptr< Capabilities > &capabilities)
bool | WillRenderSomething () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Playground
static bool | ShouldOpenNewPlaygrounds ()
static std::shared_ptr< CompressedImage > | LoadFixtureImageCompressed (std::shared_ptr< fml::Mapping > mapping)
static std::optional< DecompressedImage > | DecodeImageRGBA (const std::shared_ptr< CompressedImage > &compressed)
static std::shared_ptr< Texture > | CreateTextureForMapping (const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
static bool | SupportsBackend (PlaygroundBackend backend)
Protected Member Functions inherited from impeller::Playground
void | SetWindowSize (ISize size)
Protected Attributes inherited from impeller::Playground
const PlaygroundSwitches | switches_

## Detailed Description

Definition at line 15 of file dl_playground.h.

## Member Typedef Documentation

## ◆ DisplayListPlaygroundCallback

using impeller::DlPlayground::DisplayListPlaygroundCallback = std::function<sk_sp<flutter::DisplayList>()>

Definition at line 18 of file dl_playground.h.

## Constructor & Destructor Documentation

## ◆ DlPlayground()

impeller::DlPlayground::DlPlayground | ( |  | ) |
| default

## ◆ ~DlPlayground()

impeller::DlPlayground::~DlPlayground | ( |  | ) |
| default

## Member Function Documentation

## ◆ CreateDlImageForFixture()

sk_sp< flutter::DlImage > impeller::DlPlayground::CreateDlImageForFixture | ( | const char * | fixture_name,
|  | bool | enable_mipmapping = `false`
| ) |  | const

Definition at line 88 of file dl_playground.cc.

90 {
91 std::shared_ptr<fml::Mapping> mapping =
92 flutter::testing::OpenFixtureAsMapping(fixture_name);
93 std::shared_ptr<Texture> texture = Playground::CreateTextureForMapping(
94 GetContext(), mapping, enable_mipmapping);
95 if (texture) {
96 texture->SetLabel(fixture_name);
97 }
98 return DlImageImpeller::Make(texture);
99 }

References impeller::Playground::CreateTextureForMapping(), impeller::Playground::GetContext(), and impeller::DlImageImpeller::Make().

## ◆ CreateTestFont()

SkFont impeller::DlPlayground::CreateTestFont | ( |  | ) |

Definition at line 84 of file dl_playground.cc.

84 {
85 return CreateTestFontOfSize(50);
86 }

References CreateTestFontOfSize().

## ◆ CreateTestFontOfSize()

SkFont impeller::DlPlayground::CreateTestFontOfSize | ( | SkScalar | scalar | ) |

Definition at line 76 of file dl_playground.cc.

76 {
77 static constexpr const char* kTestFontFixture = "Roboto-Regular.ttf";
78 auto mapping = flutter::testing::OpenFixtureAsSkData(kTestFontFixture);
79 FML_CHECK(mapping);
80 sk_sp<SkFontMgr> font_mgr = txt::GetDefaultFontManager();
81 return SkFont{font_mgr->makeFromData(mapping), scalar};
82 }

Referenced by CreateTestFont().

## ◆ OpenPlaygroundHere() [1/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | DisplayListPlaygroundCallback | callback | ) |

Definition at line 34 of file dl_playground.cc.

34 {
35 if (!switches_.enable_playground) {
36 return true;
37 }
38
39 AiksContext context(GetContext(), TypographerContextSkia::Make());
40 if (!context.IsValid()) {
41 return false;
42 }
43 return Playground::OpenPlaygroundHere(
44 [&context, &callback](RenderTarget& render_target) -> bool {
45 static bool wireframe = false;
46 if (ImGui::IsKeyPressed(ImGuiKey_Z)) {
47 wireframe = !wireframe;
48 context.GetContentContext().SetWireframe(wireframe);
49 }
50
51 auto list = callback();
52
53 #if ENABLE_EXPERIMENTAL_CANVAS
54 TextFrameDispatcher collector(context.GetContentContext(), Matrix());
55 list->Dispatch(collector);
56
57 ExperimentalDlDispatcher impeller_dispatcher(
58 context.GetContentContext(), render_target,
59 list->root_has_backdrop_filter(), list->max_root_blend_mode(),
60 IRect::MakeMaximum());
61 list->Dispatch(impeller_dispatcher);
62 impeller_dispatcher.FinishRecording();
63 context.GetContentContext().GetTransientsBuffer().Reset();
64 context.GetContentContext().GetLazyGlyphAtlas()->ResetTextFrames();
65 return true;
66 #else
67 DlDispatcher dispatcher;
68 list->Dispatch(dispatcher);
69 auto picture = dispatcher.EndRecordingAsPicture();
70
71 return context.Render(picture, render_target, true);
72 #endif
73 });
74 }

References impeller::PlaygroundSwitches::enable_playground, impeller::DlDispatcherBase::EndRecordingAsPicture(), impeller::ExperimentalDlDispatcher::FinishRecording(), impeller::AiksContext::GetContentContext(), impeller::Playground::GetContext(), impeller::ContentContext::GetLazyGlyphAtlas(), impeller::ContentContext::GetTransientsBuffer(), impeller::AiksContext::IsValid(), impeller::TypographerContextSkia::Make(), impeller::TRect< T >::MakeMaximum(), impeller::Playground::OpenPlaygroundHere(), impeller::AiksContext::Render(), impeller::HostBuffer::Reset(), and impeller::Playground::switches_.

## ◆ OpenPlaygroundHere() [2/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | flutter::DisplayListBuilder & | builder | ) |

Definition at line 26 of file dl_playground.cc.

26 {
27 return OpenPlaygroundHere(builder.Build());
28 }

Referenced by OpenPlaygroundHere().

## ◆ OpenPlaygroundHere() [3/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | sk_sp< flutter::DisplayList > | list | ) |

Definition at line 30 of file dl_playground.cc.

30 {
31 return OpenPlaygroundHere([&list]() { return list; });
32 }

References OpenPlaygroundHere().

The documentation for this class was generated from the following files:

- impeller/display_list/dl_playground.h
- impeller/display_list/dl_playground.cc

impeller::DlPlayground::OpenPlaygroundHere
bool OpenPlaygroundHere(flutter::DisplayListBuilder &builder)
Definition: dl_playground.cc:26
impeller::DlImageImpeller::Make
static sk_sp< DlImageImpeller > Make(std::shared_ptr< Texture > texture, OwningContext owning_context=OwningContext::kIO)
Definition: dl_image_impeller.cc:12
impeller::DlPlayground::CreateTestFontOfSize
SkFont CreateTestFontOfSize(SkScalar scalar)
Definition: dl_playground.cc:76
impeller::Playground::switches_
const PlaygroundSwitches switches_
Definition: playground.h:118
impeller::Playground::CreateTextureForMapping
static std::shared_ptr< Texture > CreateTextureForMapping(const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
Definition: playground.cc:441
impeller::TRect::MakeMaximum
constexpr static TRect MakeMaximum()
Definition: rect.h:174
impeller::Playground::OpenPlaygroundHere
bool OpenPlaygroundHere(const Renderer::RenderCallback &render_callback)
Definition: playground.cc:204
impeller::Playground::GetContext
std::shared_ptr< Context > GetContext() const
Definition: playground.cc:90
impeller::PlaygroundSwitches::enable_playground
bool enable_playground
Definition: switches.h:16
impeller::TypographerContextSkia::Make
static std::shared_ptr< TypographerContext > Make()
Definition: typographer_context_skia.cc:78